;---------------------------------------------------------------------------
; Author        Asman
; Version       1.0
; History       2014-12-04
; Requires      -
; Copyright     Public Domain
; Language      68000 Assembler
; Translator    Barfly V2.9
;
; Game          AppleHunt
;
; $Id$
;---------------------------------------------------------------------------
	INCDIR	Includes:
	INCLUDE	whdload.i
	INCLUDE	whdmacros.i

;RELEASE

	IFD BARFLY

	OUTPUT "Ram:AppleHunt.slave"

	IFD RELEASE

	BOPT   O+             ;enable optimizing
	BOPT   OG+            ;enable optimizing

	ELSE

	BOPT   O-             ;disable optimizing
	BOPT   OG-            ;disable optimizing

	ENDC	;END IFD RELEASE

	BOPT   ODd-           ;disable mul optimizing
	BOPT   ODe-           ;disable mul optimizing
	BOPT   w4-            ;disable 64k warnings
	BOPT   wo-            ;disable optimize warnings
	SUPER

	ENDC	;END IFD BARFLY

;---------------------------------------------------------------------------
;
; \1 - nazwa procedury bez przedrostka resload_ 
;
callwhd	MACRO
		move.l	_resload(pc),a2
		jsr	resload_\1(a2)
	ENDM

CHIPMEMSIZE = $80000
FASTMEMSIZE = 0
slv_Version = 15
slv_Flags   = 0
slv_keyexit = $59 	;F10

	IFNE slv_Version-15
	FAIL   wersje powyzej 15 nie sa wspierane
	ENDC	;END IFNE slv_Version-15

slv_base	SLAVE_HEADER			;ws_Security + ws_ID
		dc.w	slv_Version		;ws_Version
		dc.w	slv_Flags		;ws_flags
_basemem	dc.l	CHIPMEMSIZE		;ws_BaseMemSize
		dc.l	0			;ws_ExecInstall
		dc.w	_start-slv_base		;ws_GameLoader
		dc.w	slv_CurrentDir-slv_base	;ws_CurrentDir
		dc.w	0			;ws_DontCache
_keydebug	dc.b	0			;ws_keydebug
_keyexit	dc.b	slv_keyexit		;ws_keyexit
_expmem		dc.l	FASTMEMSIZE		;ws_ExpMem
		dc.w	slv_name-slv_base	;ws_name
		dc.w	slv_copy-slv_base	;ws_copy
		dc.w	slv_info-slv_base	;ws_info

	IFD BARFLY
	IFND .passchk
	DOSCMD   "WDate  >T:date"
.passchk
	ENDC	;END IFND .passchk
	ENDC	;END IFD BARFLY

slv_CurrentDir	dc.b	"data",0
slv_name	dc.b	"Apple Hunt",0
slv_copy	dc.b	"19xx xxx",0
slv_info	dc.b	"installed & fixed by Asman",10
		dc.b	"Version 1.0 "

	IFD BARFLY
		INCBIN   "T:date"
	ENDC	;END IFD BARFLY
		dc.b  0
	EVEN

GAME_STARTADR = $10000

;-----------------------------------------------------------------------------
_start:
	;zachowanie bazy resload
		lea	_resload(pc),a1
		move.l	a0,(a1)

	;zaladowanie i rozpakowanie pliku
		lea	game_name(pc),a0
		lea	GAME_STARTADR,a1
		callwhd	LoadFileDecrunch

	;relokacja pliku
		lea	GAME_STARTADR,a0
		sub.l	a1,a1
		callwhd	Relocate

	;patchowanie gry
		lea	_patch_base(pc),a0
		lea	GAME_STARTADR,a1
		callwhd	Patch

	;start gry
		jmp	GAME_STARTADR
;-----------------------------------------------------------------------------
_patch_base
		PL_START
		PL_END
;-----------------------------------------------------------------------------
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
game_name	dc.b	"AppleHunt",0
	EVEN
_resload	dc.l	0
